#include <iostream>
#include <cmath>
using namespace std;

const int WYSOKOSC = 32;               // Wysoko trjkta (musi by potg 2)
const int SZEROKOSC = 2 * WYSOKOSC - 1; // Szeroko trjkta
char kanwa[WYSOKOSC][SZEROKOSC];       // Statyczna 2D tablica do rysowania

// Funkcja inicjalizujca kanw spacjami
void inicjalizujKanwe() 
{
    for (int i = 0; i < WYSOKOSC; i++) 
	{
        for (int j = 0; j < SZEROKOSC; j++) 
		{
            kanwa[i][j] = ' ';
        }
    }
}

// Rekurencyjna funkcja do rysowania trjkta Sierpiskiego
void trojkatSierpinskiego(int x, int y, int rozmiar) 
	{
    // Warunek bazowy: jeli rozmiar to 1, umie gwiazdk w pozycji (x, y)
    if (rozmiar == 1) 
	{
        kanwa[y][x] = '*';
    } else 
	{
        int nowyRozmiar = rozmiar / 2;
        
        // Rysuj trzy mniejsze trjkty
        trojkatSierpinskiego(x, y, nowyRozmiar);                    // Grny trjkt
        trojkatSierpinskiego(x - nowyRozmiar, y + nowyRozmiar, nowyRozmiar); // Dolny lewy trjkt
        trojkatSierpinskiego(x + nowyRozmiar, y + nowyRozmiar, nowyRozmiar); // Dolny prawy trjkt
    }
}

// Funkcja do wywietlania kanwy
void wyswietlKanwe() {
    for (int i = 0; i < WYSOKOSC; i++) 
	{
        for (int j = 0; j < SZEROKOSC; j++) 
		{
            cout << kanwa[i][j];
        }
        cout << endl;
    }
}

int main() 
{
    inicjalizujKanwe();                           // Inicjalizacja kanwy
    trojkatSierpinskiego(SZEROKOSC / 2, 0, WYSOKOSC); // Rysowanie trjkta Sierpiskiego
    wyswietlKanwe();                              // Wywietlanie wyniku
    return 0;
}
